package ui.auto.core.components;

import org.openqa.selenium.WebElement;
import org.testng.Assert;

import ui.auto.core.pageobjects.WebComponent;



public class CheckBox extends WebComponent {

	public CheckBox(String data) {
		super(data);
	}
	public CheckBox(WebElement element) {
		super(element);
	}
	
	public void check(boolean value){
		if (value) {
			check();
		} else {
			uncheck();
		}
	}
	
	public void check(){
		if (!element.isSelected()) element.click();
	}
	
	public void uncheck(){
		if (element.isSelected()) element.click();
	}
	@Override
	public void setValue() {
		check(data.toLowerCase().equals("true"));
	}
	@Override
	public void validate() {
		boolean expected=data.toLowerCase().equals("true");
		boolean actual=element.isSelected();
		Assert.assertEquals(actual,expected);
	}
	
	
	

}
