/*
Copyright 2010-2012 Michael Braiman

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package ui.auto.core.pageobjects;

import java.lang.reflect.Method;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.pagefactory.ElementLocator;

import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;

public class ComponentMethodInterceptor implements MethodInterceptor {
	private ElementLocator locator;
	
	
	public ComponentMethodInterceptor(ElementLocator locator) {
		this.locator=locator;
	}
	
	@Override
	public Object intercept(Object obj, Method method, Object[] args,MethodProxy proxy) throws Throwable {
			String methodName=method.getName();
			if (!"setData".equals(methodName) && !"getData".equals(methodName) 
					&& !"init".equals(methodName) && !"finalize".equals(methodName)){		
				//System.out.println("Method: " + method.getName() + " invoked!");
				WebElement element=locator.findElement();
				((WebComponent) obj).element=element;
				((WebComponent) obj).init();
			}		
			Object retValue=proxy.invokeSuper(obj, args);
			return retValue;	
	}
	
}


